=== modified file 'ChangeLog'
--- ChangeLog	2006-08-20 16:41:46 +0000
+++ ChangeLog	2006-08-20 20:58:17 +0000
@@ -1,5 +1,8 @@
 2006-08-20  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * po/olive-gtk.pot: regenerated
+    * olive/frontend/gtk/push.py: added basic test functionality
+    * olive.glade: added test related widgets to the Push dialog
     * po/olive-gtk.pot: generated new .pot file
     * olive/frontend/gtk/bookmark.py: implemented Edit bookmark dialog
     * cmenu.ui: added Edit item to left context menu

=== modified file 'TODO'
--- TODO	2006-08-20 16:41:46 +0000
+++ TODO	2006-08-20 20:58:17 +0000
@@ -9,7 +9,7 @@
 [DONE] Display the count of pushed revisions on push (phanatic)
  - Display the commit file selector as a tree (so whole directories can be
    toggled) (j-a-meinel)
- - "Probe location" button on the Push dialog (test write access, etc.) (ddaa)
+[DONE] "Probe location" button on the Push dialog (test write access, etc.) (ddaa)
 [DONE] Save and restore main window position and size (phanatic)
 [DONE] Real sensitive context menu - e.g. options are grey if not a branch
    (phanatic)

=== modified file 'olive.glade'
--- olive.glade	2006-08-20 16:41:46 +0000
+++ olive.glade	2006-08-20 20:58:17 +0000
@@ -1663,7 +1663,7 @@
 </widget>
 
 <widget class="GtkWindow" id="window_push">
-  <property name="width_request">300</property>
+  <property name="width_request">320</property>
   <property name="title" translatable="yes">Olive - Push</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -1820,12 +1820,82 @@
       </child>
 
       <child>
+	<widget class="GtkHBox" id="hbox_push_test">
+	  <property name="visible">True</property>
+	  <property name="homogeneous">False</property>
+	  <property name="spacing">5</property>
+
+	  <child>
+	    <widget class="GtkImage" id="image_push_test">
+	      <property name="width_request">22</property>
+	      <property name="height_request">22</property>
+	      <property name="visible">True</property>
+	      <property name="icon_size">4</property>
+	      <property name="icon_name">gtk-dialog-info</property>
+	      <property name="xalign">0.5</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">False</property>
+	      <property name="fill">False</property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkLabel" id="label_push_test">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">(click the Test button to check write access)</property>
+	      <property name="use_underline">False</property>
+	      <property name="use_markup">False</property>
+	      <property name="justify">GTK_JUSTIFY_LEFT</property>
+	      <property name="wrap">False</property>
+	      <property name="selectable">False</property>
+	      <property name="xalign">0.5</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	      <property name="width_chars">-1</property>
+	      <property name="single_line_mode">False</property>
+	      <property name="angle">0</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">False</property>
+	      <property name="fill">False</property>
+	    </packing>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
 	<widget class="GtkHButtonBox" id="hbuttonbox_push">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_END</property>
 	  <property name="spacing">3</property>
 
 	  <child>
+	    <widget class="GtkButton" id="button_push_test">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label" translatable="yes">_Test</property>
+	      <property name="use_underline">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_push_test_clicked" last_modification_time="Sun, 20 Aug 2006 20:01:01 GMT"/>
+	    </widget>
+	  </child>
+
+	  <child>
 	    <widget class="GtkButton" id="button_push_cancel">
 	      <property name="visible">True</property>
 	      <property name="can_default">True</property>
@@ -1917,7 +1987,7 @@
 	<packing>
 	  <property name="padding">0</property>
 	  <property name="expand">False</property>
-	  <property name="fill">True</property>
+	  <property name="fill">False</property>
 	</packing>
       </child>
     </widget>

=== modified file 'olive/frontend/gtk/push.py'
--- olive/frontend/gtk/push.py	2006-08-20 13:02:35 +0000
+++ olive/frontend/gtk/push.py	2006-08-20 20:58:17 +0000
@@ -49,6 +49,7 @@
         # Dictionary for signal_autoconnect
         dic = { "on_button_push_push_clicked": self.push,
                 "on_button_push_cancel_clicked": self.close,
+                "on_button_push_test_clicked": self.test,
                 "on_radiobutton_push_stored_toggled": self.stored_toggled,
                 "on_radiobutton_push_specific_toggled": self.specific_toggled, }
         
@@ -56,11 +57,15 @@
         self.glade.signal_autoconnect(dic)
         
         # Get some useful widgets
+        self.radio_stored = self.glade.get_widget('radiobutton_push_stored')
+        self.radio_specific = self.glade.get_widget('radiobutton_push_specific')
         self.entry_stored = self.glade.get_widget('entry_push_stored')
         self.entry_location = self.glade.get_widget('entry_push_location')
         self.check_remember = self.glade.get_widget('checkbutton_push_remember')
         self.check_overwrite = self.glade.get_widget('checkbutton_push_overwrite')
         self.check_create = self.glade.get_widget('checkbutton_push_create')
+        self.label_test = self.glade.get_widget('label_push_test')
+        self.image_test = self.glade.get_widget('image_push_test')
         
         # Get stored location
         self.notbranch = False
@@ -109,12 +114,9 @@
             self.check_create.hide()
     
     def push(self, widget):
-        radio_stored = self.glade.get_widget('radiobutton_push_stored')
-        radio_specific = self.glade.get_widget('radiobutton_push_specific')
-        
         revs = 0
         self.comm.set_busy(self.window)
-        if radio_stored.get_active():
+        if self.radio_stored.get_active():
             try:
                 revs = commit.push(self.comm.get_path(),
                                    overwrite=self.check_overwrite.get_active())
@@ -136,7 +138,7 @@
                 return
             except:
                 raise
-        elif radio_specific.get_active():
+        elif self.radio_specific.get_active():
             location = self.entry_location.get_text()
             if location == '':
                 self.dialog.error_dialog(_('No location specified'),
@@ -178,5 +180,31 @@
         self.dialog.info_dialog(_('Push successful'),
                                 _('%d revision(s) pushed.') % revs)
     
+    def test(self, widget):
+        """ Test if write access possible. """
+        import re
+        _urlRE = re.compile(r'^(?P<proto>[^:/\\]+)://(?P<path>.*)$')
+        
+        if self.radio_stored.get_active():
+            url = self.entry_stored.get_text()
+        elif self.radio_specific.get_active():
+            url = self.entry_location.get_text()
+        
+        m = _urlRE.match(url)
+        if m:
+            proto = m.groupdict()['proto']
+            if (proto == 'sftp') or (proto == 'file'):
+                # have write acces (most probably)
+                self.image_test.set_from_stock(gtk.STOCK_YES, 4)
+                self.label_test.set_markup(_('<b>Write access is available most probably</b>'))
+            else:
+                # no write access
+                self.image_test.set_from_stock(gtk.STOCK_NO, 4)
+                self.label_test.set_markup(_('<b>No write access</b>'))
+        else:
+            # couldn't determine
+            self.image_test.set_from_stock(gtk.STOCK_DIALOG_QUESTION, 4)
+            self.label_test.set_markup(_('<b>Could not determine</b>'))
+    
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'po/olive-gtk.pot'
--- po/olive-gtk.pot	2006-08-20 16:41:46 +0000
+++ po/olive-gtk.pot	2006-08-20 20:58:17 +0000
@@ -8,7 +8,7 @@
 msgstr ""
 "Project-Id-Version: PACKAGE VERSION\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2006-08-20 18:38+0200\n"
+"POT-Creation-Date: 2006-08-20 22:56+0200\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
@@ -177,19 +177,19 @@
 msgid "Olive - Branch"
 msgstr ""
 
-#: olive.glade:1012 olive.glade:1963
+#: olive.glade:1012 olive.glade:2033
 msgid "Branch location:"
 msgstr ""
 
-#: olive.glade:1040 olive.glade:1991
+#: olive.glade:1040 olive.glade:2061
 msgid "Destination:"
 msgstr ""
 
-#: olive.glade:1068 olive.glade:2019
+#: olive.glade:1068 olive.glade:2089
 msgid "Please select a folder"
 msgstr ""
 
-#: olive.glade:1108 olive.glade:2059
+#: olive.glade:1108 olive.glade:2129
 msgid "Revision number:"
 msgstr ""
 
@@ -273,255 +273,263 @@
 msgid "_Overwrite target if diverged"
 msgstr ""
 
-#: olive.glade:1889
+#: olive.glade:1850
+msgid "(click the Test button to check write access)"
+msgstr ""
+
+#: olive.glade:1890
+msgid "_Test"
+msgstr ""
+
+#: olive.glade:1959
 msgid "_Push"
 msgstr ""
 
-#: olive.glade:1929
+#: olive.glade:1999
 msgid "Olive - Checkout"
 msgstr ""
 
-#: olive.glade:2109
+#: olive.glade:2179
 msgid "Lightweight checkout"
 msgstr ""
 
-#: olive.glade:2201
+#: olive.glade:2271
 msgid "C_heckout"
 msgstr ""
 
-#: olive.glade:2242
+#: olive.glade:2312
 msgid "Olive - Diff"
 msgstr ""
 
-#: olive.glade:2359
+#: olive.glade:2429
 msgid "Olive - Status"
 msgstr ""
 
-#: olive.glade:2443
+#: olive.glade:2513
 msgid "Olive - Make directory"
 msgstr ""
 
-#: olive.glade:2489
+#: olive.glade:2559
 msgid "_Versioned directory"
 msgstr ""
 
-#: olive.glade:2571
+#: olive.glade:2641
 msgid "_Make directory"
 msgstr ""
 
-#: olive.glade:2611
+#: olive.glade:2681
 msgid "Olive - Move"
 msgstr ""
 
-#: olive.glade:2642
+#: olive.glade:2712
 msgid "Move to"
 msgstr ""
 
-#: olive.glade:2667
+#: olive.glade:2737
 msgid "Select a directory"
 msgstr ""
 
-#: olive.glade:2755
+#: olive.glade:2825
 msgid "_Move"
 msgstr ""
 
-#: olive.glade:2794
+#: olive.glade:2864
 msgid "Olive - Rename"
 msgstr ""
 
-#: olive.glade:2825
+#: olive.glade:2895
 msgid "Rename to"
 msgstr ""
 
-#: olive.glade:2941
+#: olive.glade:3011
 msgid "_Rename"
 msgstr ""
 
-#: olive.glade:2980
+#: olive.glade:3050
 msgid "Olive - Informations"
 msgstr ""
 
-#: olive.glade:3020
+#: olive.glade:3090
 msgid "Light checkout root: "
 msgstr ""
 
-#: olive.glade:3047
+#: olive.glade:3117
 msgid "Shared repository: "
 msgstr ""
 
-#: olive.glade:3074
+#: olive.glade:3144
 msgid "Repository branch: "
 msgstr ""
 
-#: olive.glade:3101
+#: olive.glade:3171
 msgid "Checkout of branch: "
 msgstr ""
 
-#: olive.glade:3128
+#: olive.glade:3198
 msgid "Repository checkout: "
 msgstr ""
 
-#: olive.glade:3155
+#: olive.glade:3225
 msgid "Branch root: "
 msgstr ""
 
-#: olive.glade:3182
+#: olive.glade:3252
 msgid "Checkout root: "
 msgstr ""
 
-#: olive.glade:3209 olive.glade:3235 olive.glade:3261 olive.glade:3287
-#: olive.glade:3313 olive.glade:3339 olive.glade:3365 olive.glade:3493
-#: olive.glade:3519 olive.glade:3701 olive.glade:3727 olive.glade:3753
-#: olive.glade:3779 olive.glade:3934 olive.glade:3960 olive.glade:3986
-#: olive.glade:4114 olive.glade:4140 olive.glade:4430 olive.glade:4456
-#: olive.glade:4482 olive.glade:4508 olive.glade:4534 olive.glade:4560
-#: olive.glade:4586 olive.glade:4612 olive.glade:4821 olive.glade:4847
-#: olive.glade:4873 olive.glade:4899 olive.glade:4925 olive.glade:5053
-#: olive.glade:5079
+#: olive.glade:3279 olive.glade:3305 olive.glade:3331 olive.glade:3357
+#: olive.glade:3383 olive.glade:3409 olive.glade:3435 olive.glade:3563
+#: olive.glade:3589 olive.glade:3771 olive.glade:3797 olive.glade:3823
+#: olive.glade:3849 olive.glade:4004 olive.glade:4030 olive.glade:4056
+#: olive.glade:4184 olive.glade:4210 olive.glade:4500 olive.glade:4526
+#: olive.glade:4552 olive.glade:4578 olive.glade:4604 olive.glade:4630
+#: olive.glade:4656 olive.glade:4682 olive.glade:4891 olive.glade:4917
+#: olive.glade:4943 olive.glade:4969 olive.glade:4995 olive.glade:5123
+#: olive.glade:5149
 msgid "(none)"
 msgstr ""
 
-#: olive.glade:3394 olive.glade:5203
+#: olive.glade:3464 olive.glade:5273
 msgid "Location:"
 msgstr ""
 
-#: olive.glade:3439
+#: olive.glade:3509
 msgid "Parent branch: "
 msgstr ""
 
-#: olive.glade:3466
+#: olive.glade:3536
 msgid "Publish to branch: "
 msgstr ""
 
-#: olive.glade:3548
+#: olive.glade:3618
 msgid "Related branches:"
 msgstr ""
 
-#: olive.glade:3593
+#: olive.glade:3663
 msgid "Control format: "
 msgstr ""
 
-#: olive.glade:3620
+#: olive.glade:3690
 msgid "Working tree format: "
 msgstr ""
 
-#: olive.glade:3647
+#: olive.glade:3717
 msgid "Branch format: "
 msgstr ""
 
-#: olive.glade:3674
+#: olive.glade:3744
 msgid "Repository format: "
 msgstr ""
 
-#: olive.glade:3808
+#: olive.glade:3878
 msgid "Format:"
 msgstr ""
 
-#: olive.glade:3853
+#: olive.glade:3923
 msgid "Working tree lock status: "
 msgstr ""
 
-#: olive.glade:3880
+#: olive.glade:3950
 msgid "Branch lock status: "
 msgstr ""
 
-#: olive.glade:3907
+#: olive.glade:3977
 msgid "Repository lock status: "
 msgstr ""
 
-#: olive.glade:4015
+#: olive.glade:4085
 msgid "Lock status:"
 msgstr ""
 
-#: olive.glade:4060
+#: olive.glade:4130
 msgid "Missing revisions in working tree: "
 msgstr ""
 
-#: olive.glade:4087
+#: olive.glade:4157
 msgid "Missing revisions in branch: "
 msgstr ""
 
-#: olive.glade:4169
+#: olive.glade:4239
 msgid "Missing revisions:"
 msgstr ""
 
-#: olive.glade:4214
+#: olive.glade:4284
 msgid "Unchanged files: "
 msgstr ""
 
-#: olive.glade:4241
+#: olive.glade:4311
 msgid "Modified files: "
 msgstr ""
 
-#: olive.glade:4268
+#: olive.glade:4338
 msgid "Added files: "
 msgstr ""
 
-#: olive.glade:4295
+#: olive.glade:4365
 msgid "Removed files: "
 msgstr ""
 
-#: olive.glade:4322
+#: olive.glade:4392
 msgid "Renamed files: "
 msgstr ""
 
-#: olive.glade:4349
+#: olive.glade:4419
 msgid "Unknown files: "
 msgstr ""
 
-#: olive.glade:4376
+#: olive.glade:4446
 msgid "Ignored files: "
 msgstr ""
 
-#: olive.glade:4403
+#: olive.glade:4473
 msgid "Versioned subdirectories: "
 msgstr ""
 
-#: olive.glade:4641
+#: olive.glade:4711
 msgid "In the working tree:"
 msgstr ""
 
-#: olive.glade:4686
+#: olive.glade:4756
 msgid "Revisions in branch: "
 msgstr ""
 
-#: olive.glade:4713
+#: olive.glade:4783
 msgid "Number of commiters: "
 msgstr ""
 
-#: olive.glade:4740
+#: olive.glade:4810
 msgid "Age of branch in days: "
 msgstr ""
 
-#: olive.glade:4767
+#: olive.glade:4837
 msgid "Time of first revision: "
 msgstr ""
 
-#: olive.glade:4794
+#: olive.glade:4864
 msgid "Time of last revision: "
 msgstr ""
 
-#: olive.glade:4954
+#: olive.glade:5024
 msgid "Branch history:"
 msgstr ""
 
-#: olive.glade:4999
+#: olive.glade:5069
 msgid "Revisions in repository: "
 msgstr ""
 
-#: olive.glade:5026
+#: olive.glade:5096
 msgid "Size of repository: "
 msgstr ""
 
-#: olive.glade:5108
+#: olive.glade:5178
 msgid "Revision store:"
 msgstr ""
 
-#: olive.glade:5169
+#: olive.glade:5239
 msgid "Edit bookmark - Olive"
 msgstr ""
 
-#: olive.glade:5231
+#: olive.glade:5301
 msgid "Title:"
 msgstr ""
 
@@ -536,14 +544,14 @@
 msgstr ""
 
 #: add.py:77 add.py:88 commit.py:96 commit.py:171 diff.py:106 handler.py:82
-#: info.py:485 log.py:63 menu.py:139 menu.py:161 push.py:79 push.py:122
-#: push.py:152 remove.py:77 remove.py:93 status.py:139
+#: info.py:485 log.py:63 menu.py:139 menu.py:161 push.py:84 push.py:124
+#: push.py:154 remove.py:77 remove.py:93 status.py:139
 msgid "Directory is not a branch"
 msgstr ""
 
 #: add.py:78 add.py:89 commit.py:97 commit.py:172 diff.py:107 handler.py:83
-#: info.py:486 log.py:64 menu.py:140 menu.py:162 push.py:80 push.py:123
-#: push.py:153 remove.py:78 remove.py:94 status.py:140
+#: info.py:486 log.py:64 menu.py:140 menu.py:162 push.py:85 push.py:125
+#: push.py:155 remove.py:78 remove.py:94 status.py:140
 msgid "You can perform this action only in a branch."
 msgstr ""
 
@@ -585,11 +593,11 @@
 "already exists. Please select another target."
 msgstr ""
 
-#: branch.py:91 checkout.py:94 push.py:130 push.py:157
+#: branch.py:91 checkout.py:94 push.py:132 push.py:159
 msgid "Non existing parent directory"
 msgstr ""
 
-#: branch.py:92 checkout.py:95 push.py:131 push.py:158
+#: branch.py:92 checkout.py:95 push.py:133 push.py:160
 #, python-format
 msgid ""
 "The parent directory (%s)\n"
@@ -923,51 +931,63 @@
 msgid "The destination is not in the same branch."
 msgstr ""
 
-#: push.py:126
+#: push.py:128
 msgid "Push location is unknown"
 msgstr ""
 
-#: push.py:127
+#: push.py:129
 msgid "Please specify a location manually."
 msgstr ""
 
-#: push.py:134 push.py:162
+#: push.py:136 push.py:164
 msgid "Branches have been diverged"
 msgstr ""
 
-#: push.py:135 push.py:163
+#: push.py:137 push.py:165
 msgid ""
 "You cannot push if branches have diverged. Use the\n"
 "overwrite option if you want to push anyway."
 msgstr ""
 
-#: push.py:142
+#: push.py:144
 msgid "No location specified"
 msgstr ""
 
-#: push.py:143
+#: push.py:145
 msgid "Please specify a location or use the default."
 msgstr ""
 
-#: push.py:167
+#: push.py:169
 msgid "Path prefix not created"
 msgstr ""
 
-#: push.py:168
+#: push.py:170
 msgid ""
 "The path leading up to the specified location couldn't\n"
 "be created."
 msgstr ""
 
-#: push.py:178
+#: push.py:180
 msgid "Push successful"
 msgstr ""
 
-#: push.py:179
+#: push.py:181
 #, python-format
 msgid "%d revision(s) pushed."
 msgstr ""
 
+#: push.py:199
+msgid "<b>Write access is available most probably</b>"
+msgstr ""
+
+#: push.py:203
+msgid "<b>No write access</b>"
+msgstr ""
+
+#: push.py:207
+msgid "<b>Could not determine</b>"
+msgstr ""
+
 #: remove.py:98
 msgid "No matching files"
 msgstr ""

